/*
** Alias OBJ 形式データ
*/
#ifndef OBJ_H
#define OBJ_H

#if defined(WIN32)
#  include "glew.h"
#  include <GL/gl.h>
#elif defined(__APPLE__) || defined(MACOSX)
#  include <OpenGL/gl.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/gl.h>
#endif

typedef float Vec[3];
typedef unsigned int Idx[3];

class Obj {
  int nv, nf;                                             // 頂点の数，面の数
  Vec *vert, *norm, *fnorm;                               // 頂点，頂点の法線，面の法線
  Idx *face;                                              // 面データ（頂点のインデックス）
  void init();                                            // 初期化
  void copy(const Obj &);                                 // メモリのコピー
public:
  Obj();
  Obj(const Obj &o);
  ~Obj();
  Obj &operator=(const Obj &o);
  bool load(const char *name);                            // OBJ ファイルの読み込み
  void draw(GLint pos, GLint vec, GLsizei points) const;  // 図形の描画
};

#endif
